"""
    Delphix DCT API

    Delphix DCT API  # noqa: E501

    The version of the OpenAPI document: 3.22.0
    Contact: support@delphix.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from delphix.api.gateway.api_client import ApiClient, Endpoint as _Endpoint
from delphix.api.gateway.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from delphix.api.gateway.model.delete_held_space_response import DeleteHeldSpaceResponse
from delphix.api.gateway.model.held_space_deletion_dependencies_response import HeldSpaceDeletionDependenciesResponse


class HeldSpaceApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __delete_heldspace_by_id(
            self,
            heldspace_id,
            **kwargs
        ):
            """Delete a HeldSpace.  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.delete_heldspace_by_id(heldspace_id, async_req=True)
            >>> result = thread.get()

            Args:
                heldspace_id (str): The heldspace id to filter by.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                DeleteHeldSpaceResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['heldspace_id'] = \
                heldspace_id
            return self.call_with_http_info(**kwargs)

        self.delete_heldspace_by_id = _Endpoint(
            settings={
                'response_type': (DeleteHeldSpaceResponse,),
                'auth': [
                    'ApiKeyAuth'
                ],
                'endpoint_path': '/heldspace/{heldspaceId}/delete',
                'operation_id': 'delete_heldspace_by_id',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'heldspace_id',
                ],
                'required': [
                    'heldspace_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'heldspace_id',
                ]
            },
            root_map={
                'validations': {
                    ('heldspace_id',): {

                        'min_length': 1,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'heldspace_id':
                        (str,),
                },
                'attribute_map': {
                    'heldspace_id': 'heldspaceId',
                },
                'location_map': {
                    'heldspace_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__delete_heldspace_by_id
        )

        def __get_heldspace_deletion_dependencies(
            self,
            heldspace_id,
            **kwargs
        ):
            """Get heldspace deletion dependencies.  # noqa: E501

            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.get_heldspace_deletion_dependencies(heldspace_id, async_req=True)
            >>> result = thread.get()

            Args:
                heldspace_id (str): The heldspace id to filter by.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (int/float/tuple): timeout setting for this request. If
                    one number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                HeldSpaceDeletionDependenciesResponse
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['heldspace_id'] = \
                heldspace_id
            return self.call_with_http_info(**kwargs)

        self.get_heldspace_deletion_dependencies = _Endpoint(
            settings={
                'response_type': (HeldSpaceDeletionDependenciesResponse,),
                'auth': [
                    'ApiKeyAuth'
                ],
                'endpoint_path': '/heldspace/{heldspaceId}/deletion-dependencies',
                'operation_id': 'get_heldspace_deletion_dependencies',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'heldspace_id',
                ],
                'required': [
                    'heldspace_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'heldspace_id',
                ]
            },
            root_map={
                'validations': {
                    ('heldspace_id',): {

                        'min_length': 1,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'heldspace_id':
                        (str,),
                },
                'attribute_map': {
                    'heldspace_id': 'heldspaceId',
                },
                'location_map': {
                    'heldspace_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client,
            callable=__get_heldspace_deletion_dependencies
        )
